// this example works using Microsoft Visual Studio 2008
// Be sure to include the following library when linking:
// WS2_32.lib 

#include "stdafx.h"
#include "Winsock2.h"
#include <string>
#include <iostream>

using namespace std;


int main(int argc, char *argv[])
{
//Initialize Windows Sockets
WSADATA wsaData;
WSAStartup(MAKEWORD(2,2), &wsaData);
//Remote Socket
sockaddr_in saRemote;
memset(&saRemote, 0, sizeof(saRemote));
//Setup remote Chamber socket info (IP address and TCP Port)
saRemote.sin_family = AF_INET;
saRemote.sin_addr.s_addr = inet_addr("192.168.4.117");
//Remote Chamber Controller IP Address
saRemote.sin_port = htons(8888);
//Remote Chamber Controller TCP Port
//Create a new TCP Socket
SOCKET s = socket(AF_INET, SOCK_STREAM, 0);
//Connect to remote Chamber Controller
connect(s, (const sockaddr *)&saRemote, sizeof(saRemote));
//IDEN? command will request identification string from Chamber Controller
string command = "IDEN?\n";
//Note we are using \r and \n as termination characters
//Send command to Chamber Controller
send(s, command.c_str(), command.length(), 0);
//Temp buffer used to store incoming data from Chamber Controller
char buffer[128];
memset(buffer, 0, sizeof(buffer));
//Receive Chamber response
recv(s, buffer, sizeof(buffer), 0);
cout << "Chamber Controller Identified as: " << buffer << endl;
//Check Chamber for Air Temperature every 5 seconds, 100 times
for(int i=0; i<100; i++)
{
	//PVAR1? requests the Process Variable for Channel 1
	//Refer to Thermotron Chamber Controller Manual for rest of I/O commands for your model
	command = "PVAR1?\r\n";
	//Send the Query Command
	send(s, command.c_str(), command.length(), 0);
	//Clean the receive buffer
	memset(buffer, 0, sizeof(buffer));
	//Receive response
	recv(s, buffer, sizeof(buffer), 0);
	//Print the temperature to console
	cout << "Current Chamber Temperature: " << buffer << endl;
	//Wait 5 seconds before checking for new temperature
	Sleep(5000);
}
//Close socket connection
closesocket(s);
//Shut down WinSock
WSACleanup();
return 0;	
	
}
